<template>
    <a
        @click.prevent="onClickNotification"
        class="flex items-center gap-3 p-3 cursor-pointer"
    >
        <!-- <div class="notification-icon"></div> -->
        <div class="flex flex-col">
            <div class="line-clamp-3 mb-1" v-html="messageComputed"></div>
            <span
                class="text-xs text-gray-500"
                :class="[
                    status === STATUS_NOTIF_UNREAD ? 'text-main-color' : ''
                ]"
            >
                {{ timeAgoConverted }}
            </span>
        </div>
        <div class="flex-1">
            <span
                class="block w-3 h-3 mx-auto  rounded-full"
                :class="[status === STATUS_NOTIF_UNREAD ? 'bg-main-color' : '']"
            ></span>
        </div>
    </a>
</template>

<script>
import { computed, toRefs } from "vue";
import { STATUS_NOTIF_UNREAD, STATUS_NOTIF_READED } from "@/constants";
import timeHelper from "@/helper/timeHelper";

import useUpdateStatusReadedNotification from "@/hooks/notification/useUpdateStatusReadedNotification";

export default {
    props: {
        notification: {
            type: Object,
            required: true
        }
    },
    setup(props) {
        const { id, message, url, created_at, status } = toRefs(
            props.notification
        );
        const {
            errorResponseUpdate,
            onUpdateStatusReadedNotification
        } = useUpdateStatusReadedNotification();

        const messageComputed = computed(() => {
            return message.value ? message.value : "Thông báo hệ thống";
        });

        const timeAgoConverted = computed(() => {
            return timeHelper.convertTimeAgo(
                timeHelper.getTimeInt(created_at.value)
            );
        });

        async function onClickNotification() {
            await onUpdateStatusReadedNotification(id.value);
            if (!errorResponseUpdate.value) {
                status.value = STATUS_NOTIF_READED;
            }
            window.location.href = url.value;
        }

        return {
            STATUS_NOTIF_UNREAD,
            id,
            url,
            status,
            messageComputed,
            timeAgoConverted,
            onClickNotification
        };
    }
};
</script>
